#include <cstdio>
using namespace std;
typedef long long ll;
constexpr int max_n=1000;
ll a[max_n+1];
int main(){
	int n,k;
	scanf("%d%d",&n,&k);
	const int hf=n>>1;
	for(int i=1; i<=n; ++i)
		scanf("%lld",a+i);
	for(int i=1; i<=k; ++i){
		for(int i=1; i<=hf; ++i)
			a[i]+=a[n-i+1];
		for(int i=n; i; i-=2)
			a[i]=a[i-1]=a[i>>1];
		for(int i=1; i<=n; ++i)
			printf("%5lld ",a[i]);
		puts("");
	}
	return 0;
}
